/*
	desc      : wkhtmltox
	author    : raphael smart
	date      : august 2012

	licence/disclaimer:

	This software is provided 'as-is', without any express or implied warranty.
	In no event will the author be held liable for any damages arising from
	the use of this software.

	other license:

	www.mingw.org

		bin/libgcc_s_dw2-1.dll
		bin/mingwm10.dll

	openssl

		bin/libeay32.dll
		bin/ssleay32.dll

	code.google.com/p/wkhtmltopdf

		bin/libwkhtmltox.dll
		bin/libwkhtmltox.so
		include/settings.txt
*/
namespace wkhtmltox
constant __MODULENAME__ = "wkhtmltox"

include std/dll.e
include std/machine.e
include std/io.e

ifdef __TEST_WKHTML__ then
	constant LIBDIR = "./bin/"
elsedef
	constant LIBDIR = ""
end ifdef

ifdef WINDOWS then
	open_dll(LIBDIR & "mingwm10.dll")
	open_dll(LIBDIR & "libgcc_s_dw2-1.dll")
	open_dll(LIBDIR & "libeay32.dll")
	open_dll(LIBDIR & "ssleay32.dll")
	constant wkhtml_lib = open_dll("libwkhtmltox.dll")
elsedef
	constant wkhtml_lib = open_dll("libwkhtmltox.so")
end ifdef

constant wkhtmltoimage_init_ = define_c_func( wkhtml_lib, "wkhtmltoimage_init", {C_INT}, C_INT)
constant wkhtmltoimage_deinit_ = define_c_func( wkhtml_lib, "wkhtmltoimage_deinit", {}, C_INT)
constant wkhtmltoimage_extended_qt_ = define_c_func( wkhtml_lib, "wkhtmltoimage_extended_qt", {}, C_INT)
constant wkhtmltoimage_version_ = define_c_func( wkhtml_lib, "wkhtmltoimage_version", {}, C_POINTER)
constant wkhtmltoimage_create_global_settings_ = define_c_func( wkhtml_lib, "wkhtmltoimage_create_global_settings", {}, C_POINTER)
constant wkhtmltoimage_set_global_setting_ = define_c_func( wkhtml_lib, "wkhtmltoimage_set_global_setting", {C_POINTER, C_POINTER, C_POINTER}, C_INT)
constant wkhtmltoimage_get_global_setting_ = define_c_func( wkhtml_lib, "wkhtmltoimage_get_global_setting", {C_POINTER, C_POINTER, C_POINTER, C_INT}, C_INT)
constant wkhtmltoimage_create_converter_ = define_c_func( wkhtml_lib, "wkhtmltoimage_create_converter", {C_POINTER, C_POINTER}, C_POINTER)
constant wkhtmltoimage_destroy_converter_ = define_c_proc( wkhtml_lib, "wkhtmltoimage_destroy_converter", {C_POINTER})
constant wkhtmltoimage_set_warning_callback_ = define_c_proc( wkhtml_lib, "wkhtmltoimage_set_warning_callback", {C_POINTER, C_POINTER})
constant wkhtmltoimage_set_error_callback_ = define_c_proc( wkhtml_lib, "wkhtmltoimage_set_error_callback", {C_POINTER, C_POINTER})
constant wkhtmltoimage_set_phase_changed_callback_ = define_c_proc( wkhtml_lib, "wkhtmltoimage_set_phase_changed_callback", {C_POINTER, C_POINTER})
constant wkhtmltoimage_set_progress_changed_callback_ = define_c_proc( wkhtml_lib, "wkhtmltoimage_set_progress_changed_callback", {C_POINTER, C_POINTER})
constant wkhtmltoimage_set_finished_callback_ = define_c_proc( wkhtml_lib, "wkhtmltoimage_set_finished_callback", {C_POINTER, C_POINTER})
constant wkhtmltoimage_convert_ = define_c_func( wkhtml_lib, "wkhtmltoimage_convert", {C_POINTER}, C_INT)
constant wkhtmltoimage_current_phase_ = define_c_func( wkhtml_lib, "wkhtmltoimage_current_phase", {C_POINTER}, C_INT)
constant wkhtmltoimage_phase_count_ = define_c_func( wkhtml_lib, "wkhtmltoimage_phase_count", {C_POINTER}, C_INT)
constant wkhtmltoimage_phase_description_ = define_c_func( wkhtml_lib, "wkhtmltoimage_phase_description", {C_POINTER, C_INT}, C_POINTER)
constant wkhtmltoimage_progress_string_ = define_c_func( wkhtml_lib, "wkhtmltoimage_progress_string", {C_POINTER}, C_POINTER)
constant wkhtmltoimage_http_error_code_ = define_c_func( wkhtml_lib, "wkhtmltoimage_http_error_code", {C_POINTER}, C_INT)
constant wkhtmltoimage_get_output_ = define_c_func( wkhtml_lib, "wkhtmltoimage_get_output", {C_POINTER, C_POINTER}, C_LONG)
constant wkhtmltopdf_init_ = define_c_func( wkhtml_lib, "wkhtmltopdf_init", {C_INT}, C_INT)
constant wkhtmltopdf_deinit_ = define_c_func( wkhtml_lib, "wkhtmltopdf_deinit", {}, C_INT)
constant wkhtmltopdf_extended_qt_ = define_c_func( wkhtml_lib, "wkhtmltopdf_extended_qt", {}, C_INT)
constant wkhtmltopdf_version_ = define_c_func( wkhtml_lib, "wkhtmltopdf_version", {}, C_POINTER)
constant wkhtmltopdf_create_global_settings_ = define_c_func( wkhtml_lib, "wkhtmltopdf_create_global_settings", {}, C_POINTER)
constant wkhtmltopdf_create_object_settings_ = define_c_func( wkhtml_lib, "wkhtmltopdf_create_object_settings", {}, C_POINTER)
constant wkhtmltopdf_set_global_setting_ = define_c_func( wkhtml_lib, "wkhtmltopdf_set_global_setting", {C_POINTER, C_POINTER, C_POINTER}, C_INT)
constant wkhtmltopdf_get_global_setting_ = define_c_func( wkhtml_lib, "wkhtmltopdf_get_global_setting", {C_POINTER, C_POINTER, C_POINTER, C_INT}, C_INT)
constant wkhtmltopdf_set_object_setting_ = define_c_func( wkhtml_lib, "wkhtmltopdf_set_object_setting", {C_POINTER, C_POINTER, C_POINTER}, C_INT)
constant wkhtmltopdf_get_object_setting_ = define_c_func( wkhtml_lib, "wkhtmltopdf_get_object_setting", {C_POINTER, C_POINTER, C_POINTER, C_INT}, C_INT)
constant wkhtmltopdf_create_converter_ = define_c_func( wkhtml_lib, "wkhtmltopdf_create_converter", {C_POINTER}, C_POINTER)
constant wkhtmltopdf_destroy_converter_ = define_c_proc( wkhtml_lib, "wkhtmltopdf_destroy_converter", {C_POINTER})
constant wkhtmltopdf_set_warning_callback_ = define_c_proc( wkhtml_lib, "wkhtmltopdf_set_warning_callback", {C_POINTER, C_POINTER})
constant wkhtmltopdf_set_error_callback_ = define_c_proc( wkhtml_lib, "wkhtmltopdf_set_error_callback", {C_POINTER, C_POINTER})
constant wkhtmltopdf_set_phase_changed_callback_ = define_c_proc( wkhtml_lib, "wkhtmltopdf_set_phase_changed_callback", {C_POINTER, C_POINTER})
constant wkhtmltopdf_set_progress_changed_callback_ = define_c_proc( wkhtml_lib, "wkhtmltopdf_set_progress_changed_callback", {C_POINTER, C_POINTER})
constant wkhtmltopdf_set_finished_callback_ = define_c_proc( wkhtml_lib, "wkhtmltopdf_set_finished_callback", {C_POINTER, C_POINTER})
constant wkhtmltopdf_convert_ = define_c_func( wkhtml_lib, "wkhtmltopdf_convert", {C_POINTER}, C_INT)
constant wkhtmltopdf_add_object_ = define_c_proc( wkhtml_lib, "wkhtmltopdf_add_object", {C_POINTER, C_POINTER, C_POINTER})
constant wkhtmltopdf_current_phase_ = define_c_func( wkhtml_lib, "wkhtmltopdf_current_phase", {C_POINTER}, C_INT)
constant wkhtmltopdf_phase_count_ = define_c_func( wkhtml_lib, "wkhtmltopdf_phase_count", {C_POINTER}, C_INT)
constant wkhtmltopdf_phase_description_ = define_c_func( wkhtml_lib, "wkhtmltopdf_phase_description", {C_POINTER, C_INT}, C_POINTER)
constant wkhtmltopdf_progress_string_ = define_c_func( wkhtml_lib, "wkhtmltopdf_progress_string", {C_POINTER}, C_POINTER)
constant wkhtmltopdf_http_error_code_ = define_c_func( wkhtml_lib, "wkhtmltopdf_http_error_code", {C_POINTER}, C_INT)
constant wkhtmltopdf_get_output_ = define_c_func( wkhtml_lib, "wkhtmltopdf_get_output", {C_POINTER, C_POINTER}, C_LONG)

--// error/progress callbacks

--// display loading progress
function progress_changed(atom converter, integer p) 
	printf(1, "%3d%%\r",{ p })
	flush(STDOUT)
	return 0
end function

--// display phase change
function phase_changed(atom converter) 
	integer phase = current_phase(converter)
	printf(STDOUT, "%s\n", { phase_description(converter, phase) })
	return 0
end function

--// display error message
function error(atom converter, atom msg) 
	printf(STDERR, "error: %s\n", { peek_string(msg) })
	return 0
end function

--// display warning messages
function warning(atom converter, atom msg)
	printf(STDERR, "warning: %s\n", { peek_string(msg) })
	return 0
end function

--// object settings

function get_setting(atom fcall, atom settings, sequence seq_name, integer vs=0)
    object result
    atom name, val
	 if vs <= 0 then
	 	vs = 256
	 end if
    name = allocate_string(seq_name)
    val = allocate_string(repeat(#0, vs))
    result = c_func(fcall, {settings, name, val, vs})
	 result = peek_string(val)
    free(name)
    free(val)
    return result
end function

/* IMAGE */

public function image_init(integer use_graphics)
    return c_func(wkhtmltoimage_init_, {use_graphics})
end function

public function image_deinit()
    return c_func(wkhtmltoimage_deinit_, {})
end function

public function image_extended_qt()
    return c_func(wkhtmltoimage_extended_qt_, {})
end function

public function image_version()
    object result = c_func(wkhtmltoimage_version_, {})
    return peek_string( result )
end function

public function image_create_global_settings()
    return c_func(wkhtmltoimage_create_global_settings_, {})
end function

public function image_set_global_setting(atom settings, sequence seq_name, sequence seq_val)
    object result
    atom name, val
    name = allocate_string(seq_name)
    val = allocate_string(seq_val)
    result = c_func(wkhtmltoimage_set_global_setting_, {settings, name, val})
    free(name)
    free(val)
    return result
end function

public function image_get_global_setting(atom settings, sequence seq_name, integer vs)
	return get_setting(wkhtmltoimage_get_global_setting_, settings, seq_name, vs)
end function

public function image_create_converter(atom settings, sequence seq_data)
    object result
    atom data
    data = allocate_string(seq_data)
    result = c_func(wkhtmltoimage_create_converter_, {settings, data})
    free(data)
    return result
end function

public procedure image_destroy_converter(atom converter)
    c_proc(wkhtmltoimage_destroy_converter_, {converter})
end procedure

public procedure image_set_warning_callback(atom converter, atom cb)
    c_proc(wkhtmltoimage_set_warning_callback_, {converter, cb})
end procedure

public procedure image_set_error_callback(atom converter, atom cb)
    c_proc(wkhtmltoimage_set_error_callback_, {converter, cb})
end procedure

public procedure image_set_phase_changed_callback(atom converter, atom cb)
    c_proc(wkhtmltoimage_set_phase_changed_callback_, {converter, cb})
end procedure

public procedure image_set_progress_changed_callback(atom converter, atom cb)
    c_proc(wkhtmltoimage_set_progress_changed_callback_, {converter, cb})
end procedure

public procedure image_set_finished_callback(atom converter, atom cb)
    c_proc(wkhtmltoimage_set_finished_callback_, {converter, cb})
end procedure

public function image_convert(atom converter)
    return c_func(wkhtmltoimage_convert_, {converter})
end function

public function image_current_phase(atom converter)
    return c_func(wkhtmltoimage_current_phase_, {converter})
end function

public function image_phase_count(atom converter)
    return c_func(wkhtmltoimage_phase_count_, {converter})
end function

public function image_phase_description(atom converter, integer phase)
    object result = c_func(wkhtmltoimage_phase_description_, {converter, phase})
    return peek_string( result )
end function

public function image_progress_string(atom converter)
    object result = c_func(wkhtmltoimage_progress_string_, {converter})
    return peek_string( result )
end function

public function image_http_error_code(atom converter)
    return c_func(wkhtmltoimage_http_error_code_, {converter})
end function

public function image_get_output(atom converter, atom b)
    return c_func(wkhtmltoimage_get_output_, {converter, b})
end function

/* PDF */

public function init(integer use_graphics)
    return c_func(wkhtmltopdf_init_, {use_graphics})
end function

public function deinit()
    return c_func(wkhtmltopdf_deinit_, {})
end function

public function extended_qt()
    return c_func(wkhtmltopdf_extended_qt_, {})
end function

public function version()
    object result = c_func(wkhtmltopdf_version_, {})
    return peek_string( result )
end function

public function create_global_settings()
    return c_func(wkhtmltopdf_create_global_settings_, {})
end function

public function create_object_settings()
    return c_func(wkhtmltopdf_create_object_settings_, {})
end function

public function set_global_setting(atom settings, sequence seq_name, sequence seq_val)
    object result
    atom name, val
    name = allocate_string(seq_name)
    val = allocate_string(seq_val)
    result = c_func(wkhtmltopdf_set_global_setting_, {settings, name, val})
    free(name)
    free(val)
    return result
end function

public function get_global_setting(atom settings, sequence seq_name, integer vs=0)
	return get_setting(wkhtmltopdf_get_global_setting_, settings, seq_name, vs)
end function

public function set_object_setting(atom settings, sequence seq_name, sequence seq_val)
    object result
    atom name, val
    name = allocate_string(seq_name)
    val = allocate_string(seq_val)
    result = c_func(wkhtmltopdf_set_object_setting_, {settings, name, val})
    free(name)
    free(val)
    return result
end function

public function get_object_setting(atom settings, sequence seq_name, sequence seq_val, integer vs)
	return get_setting(wkhtmltopdf_get_object_setting_, settings, seq_name, vs)
end function

public function create_converter
(
	atom settings,
	sequence r_progress_changed="progress_changed",
	sequence r_phase_changed="phase_changed",
	sequence r_warning="warning",
	sequence r_error="error"
)
	atom converter = c_func(wkhtmltopdf_create_converter_, {settings})
	--// set progress callbacks
	if length(r_progress_changed) then
		set_progress_changed_callback(converter, call_back("+" & routine_id(r_progress_changed)))
	end if
	if length(r_phase_changed) then
		set_phase_changed_callback(converter,    call_back("+" & routine_id(r_phase_changed)))
	end if
	if length(r_warning) then
		set_warning_callback(converter, call_back("+" & routine_id(r_warning)))
	end if
	if length(r_error) then
		set_error_callback(converter,   call_back("+" & routine_id(r_error)))
	end if
	return converter
end function

public procedure destroy_converter(atom converter)
    c_proc(wkhtmltopdf_destroy_converter_, {converter})
end procedure

public procedure set_warning_callback(atom converter, atom cb)
    c_proc(wkhtmltopdf_set_warning_callback_, {converter, cb})
end procedure

public procedure set_error_callback(atom converter, atom cb)
    c_proc(wkhtmltopdf_set_error_callback_, {converter, cb})
end procedure

public procedure set_phase_changed_callback(atom converter, atom cb)
    c_proc(wkhtmltopdf_set_phase_changed_callback_, {converter, cb})
end procedure

public procedure set_progress_changed_callback(atom converter, atom cb)
    c_proc(wkhtmltopdf_set_progress_changed_callback_, {converter, cb})
end procedure

public procedure set_finished_callback(atom converter, atom cb)
    c_proc(wkhtmltopdf_set_finished_callback_, {converter, cb})
end procedure

public function convert(atom converter)
    return c_func(wkhtmltopdf_convert_, {converter})
end function

public procedure add_object(atom converter, atom setting, sequence seq_data)
    atom data
    data = allocate_string(seq_data)
    c_proc(wkhtmltopdf_add_object_, {converter, setting, data})
	 free(data)
end procedure

public function current_phase(atom converter)
    return c_func(wkhtmltopdf_current_phase_, {converter})
end function

public function phase_count(atom converter)
    return c_func(wkhtmltopdf_phase_count_, {converter})
end function

public function phase_description(atom converter, integer phase)
    object result = c_func(wkhtmltopdf_phase_description_, {converter, phase})
    return peek_string( result )
end function

public function progress_string(atom converter)
    object result = c_func(wkhtmltopdf_progress_string_, {converter})
    return peek_string( result )
end function

public function http_error_code(atom converter)
    return c_func(wkhtmltopdf_http_error_code_, {converter})
end function

public function get_output(atom converter, atom b)
    return c_func(wkhtmltopdf_get_output_, {converter, b})
end function

ifdef __TEST_WKHTML_IMPORTS__ then
	printf(1, "%-40s = %d\n", { "wkhtml_lib", wkhtml_lib})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_init_", wkhtmltoimage_init_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_deinit_", wkhtmltoimage_deinit_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_extended_qt_", wkhtmltoimage_extended_qt_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_version_", wkhtmltoimage_version_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_create_global_settings_", wkhtmltoimage_create_global_settings_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_set_global_setting_", wkhtmltoimage_set_global_setting_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_get_global_setting_", wkhtmltoimage_get_global_setting_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_create_converter_", wkhtmltoimage_create_converter_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_destroy_converter_", wkhtmltoimage_destroy_converter_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_set_warning_callback_", wkhtmltoimage_set_warning_callback_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_set_error_callback_", wkhtmltoimage_set_error_callback_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_set_phase_changed_callback_", wkhtmltoimage_set_phase_changed_callback_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_set_progress_changed_callback_", wkhtmltoimage_set_progress_changed_callback_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_set_finished_callback_", wkhtmltoimage_set_finished_callback_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_convert_", wkhtmltoimage_convert_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_current_phase_", wkhtmltoimage_current_phase_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_phase_count_", wkhtmltoimage_phase_count_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_phase_description_", wkhtmltoimage_phase_description_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_progress_string_", wkhtmltoimage_progress_string_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_http_error_code_", wkhtmltoimage_http_error_code_})
	printf(1, "%-40s = %d\n", { "wkhtmltoimage_get_output_", wkhtmltoimage_get_output_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_init_", wkhtmltopdf_init_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_deinit_", wkhtmltopdf_deinit_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_extended_qt_", wkhtmltopdf_extended_qt_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_version_", wkhtmltopdf_version_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_create_global_settings_", wkhtmltopdf_create_global_settings_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_create_object_settings_", wkhtmltopdf_create_object_settings_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_set_global_setting_", wkhtmltopdf_set_global_setting_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_get_global_setting_", wkhtmltopdf_get_global_setting_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_set_object_setting_", wkhtmltopdf_set_object_setting_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_get_object_setting_", wkhtmltopdf_get_object_setting_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_create_converter_", wkhtmltopdf_create_converter_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_destroy_converter_", wkhtmltopdf_destroy_converter_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_set_warning_callback_", wkhtmltopdf_set_warning_callback_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_set_error_callback_", wkhtmltopdf_set_error_callback_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_set_phase_changed_callback_", wkhtmltopdf_set_phase_changed_callback_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_set_progress_changed_callback_", wkhtmltopdf_set_progress_changed_callback_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_set_finished_callback_", wkhtmltopdf_set_finished_callback_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_convert_", wkhtmltopdf_convert_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_add_object_", wkhtmltopdf_add_object_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_current_phase_", wkhtmltopdf_current_phase_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_phase_count_", wkhtmltopdf_phase_count_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_phase_description_", wkhtmltopdf_phase_description_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_progress_string_", wkhtmltopdf_progress_string_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_http_error_code_", wkhtmltopdf_http_error_code_})
	printf(1, "%-40s = %d\n", { "wkhtmltopdf_get_output_", wkhtmltopdf_get_output_})
end ifdef
